//
//	CProp.h
//
//	class CProp
//	Class for manipulating a QD3D object that may be
//	spun and tossed independently.
//
//	by James Jennings
//	Started November 23, 1995
//
//	Note: Be sure to call MakeModel() after construction.
//	I can't call MakeModel() from the constructor because
//	I plan to override it.
//

#pragma once

#include "CObjectMaker.h"

class CProp {
private:
public:
					CProp();
					CProp(const CProp & prop);
				//	CProp(const TQ3FileObject & source);
	virtual			~CProp();
	
			TQ3GroupObject	Get() { return mModel; }
	virtual	void			SetPosition(TQ3Point3D &where);
	virtual	void			SetSpinAngle(float theta);
	virtual	void			SetTiltAngle(float theta);
	
	virtual void	MakeModel(CObjectMaker<TQ3GeometryObject> &aThing, TQ3Point3D &anOrigin);
protected:
	virtual void	MakeThing(CObjectMaker<TQ3GeometryObject> &aThing);
	
protected:
			void		Dispose();
	TQ3GroupObject		mModel;	// the entire model: A QD3D version of this class
	TQ3GeometryObject	mThing;	// the geometry
		// we keep references to the transforms so we can update them easily
	TQ3TransformObject	mTranslation;
	TQ3TransformObject	mSpin;			// about the Y-Axis
	TQ3TransformObject	mTilt;			// change plane of the spin
};
