//
//	CPropPane.h
//
//	class CPropPane
//	A Pane for rendering 4 boxes in a QuickDraw 3D view.
//	Borrowed heavily from the "START HERE" sample code from Apple.
//
//	by James Jennings
//	November 22, 1995
//

#pragma once

//#include "CQD3DPane.h"
#include "CQD3DGimbalPane.h"
#include "CProp.h"

class CPropPane : public CQD3DGimbalPane, LPeriodical, LCommander {
public:
	enum { class_ID = 'Prop' };
	typedef enum { prop_Cube, prop_Club } PropType;
	static CPropPane*	CreatePropPaneStream(LStream *inStream);
	
					CPropPane();
					CPropPane(const CPropPane &inOriginal);		
					CPropPane(LStream *inStream);
	virtual			~CPropPane();
	virtual void	FinishCreateSelf();
	
protected:
	// Override to build a custom view.
	virtual void	MakeCamera();
	virtual void	MakeLightGroup();
	virtual void	MakeModel();

	virtual TQ3Status	SubmitScene();
	virtual Boolean		ClickLoop( const EventRecord &inMacEvent);
public:
	// LPeriodical methods
	virtual	void	SpendTime( const EventRecord &inMacEvent);
	// LCommander methods
	virtual Boolean		ObeyCommand(CommandT inCommand, void* ioParam);	
	virtual void		FindCommandStatus(CommandT inCommand,
							Boolean &outEnabled, Boolean &outUsesMark,
							Char16 &outMark, Str255 outName);
protected:
	CProp		mClub, mCube;
	PropType	mPropType;
	Boolean		mJitterbug;
};
